//+------------------------------------------------------------------+
//|                                                    M_qRMA.mq4 |
//|                                             Copyright  2008, AP |
//|                                                olgapob33@mail.ru |
//|     Mathemat                              |
/// http://forum.mql4.com/ru/10446/page29                            |
//+------------------------------------------------------------------+
/*
Quadratic Regression MA = 3 * SMA + QWMA * ( 10 - 15/( N + 2 ) ) - LWMA * ( 12 - 15/( N + 2 ) )

 N -  , 

QWMA( i; N ) = 1/( N*(N+1)(2*N+1) ) * sum( Close[i] * (N-i)^2; i = 0..N-1 ) (   ).
*/

#property copyright "Copyright  2008, AP"
#property link      "olgapob33@mail.ru"
#property link "http://forum.mql4.com/ru/10446/page29"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Yellow

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
#define max 3000

extern int N_Period=8;
extern int qW_Price=0;
extern int LWMA_Price=0;

double qRma[];
double N;
int init()
  { int i; double sum;
  
//---- indicators
//----
   
  SetIndexBuffer(0,qRma);          
  SetIndexStyle(0,DRAW_LINE);
  SetIndexDrawBegin(0,N_Period+1);
  N=N_Period;
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() { return(0); }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+


int start()
  {int i,limit; int    counted_bars=IndicatorCounted();
   double sum;
   if(max<Bars) limit=max-counted_bars-1-N_Period; else limit=Bars-counted_bars-1-N_Period;
   
   for(i=0;i<limit;i++)
   qRma[i]=3*iMA(NULL,0,N_Period,0,0,0,i) 
   + iCustom(NULL,0,"M-qWMA",N_Period,qW_Price,0,i)*(10.-15./(N+2))   
   - iMA(NULL,0,N_Period,0,MODE_LWMA,LWMA_Price,i)*(12.-15./(N+2));  
 
    return(0);
  }
//+------------------------------------------------------------------+